UNIT BIGDATA_COLLECT
	SYSTEM FP220AE

//-------------------------------------------------------------------------------------------------------
//
// Units
//
//-------------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------------
//
// CONST/VAR/ALIAS
//
//------------------------------------------------------------------------------------------------------

CONST
MAX_COLLECT_TIMER_OFFSET                                 : VALUE := 10000000;//=10000sec
MAX_COLLECT_SEAM_STITCH                                  : VALUE := 20000;


ARRAY_COLLECT_NR           : VALUE := 1;
ARRAY_COLLECT_MAX_STACKS   : VALUE := 2;
ARRAY_COLLECT_MAX_SECTIONS : VALUE := 20;
ARRAY_COLLECT_MAX_VALUES   : VALUE := 10;

AC_RUN_TIME                : VALUE := 1;
AC_STOP_TIME               : VALUE := 2;
AC_STITCHES                : VALUE := 3;
AC_RUN_INPUTS              : VALUE := 4;
AC_RUN_OUTPUTS             : VALUE := 5;
AC_STOP_INPUTS             : VALUE := 6;
AC_STOP_OUTPUTS            : VALUE := 7;


//Values for BitOperator()
BIT_OPERATOR_AND                                 : VALUE := 1;
BIT_OPERATOR_OR                                  : VALUE := 2;
BIT_OPERATOR_XOR                                 : VALUE := 3;
BIT_OPERATOR_NOT                                 : VALUE := 4;
BIT_OPERATOR_SHIFT_RIGHT                         : VALUE := 5;
BIT_OPERATOR_SHIFT_LEFT                          : VALUE := 6;



VAR
AC_Section_Counter         : VALUE := 0;
AC_Stack                   : VALUE := 0;
AC_GetVal                  : VALUE := 0;
AC_BETWEENSEAMS_TEMP       : VALUE := 0;
AC_BETWEENSEAMS_LAST_SEAM  : VALUE := 0;

AC_ONE_Section             : VALUE := 0;
AC_TWO_Section             : VALUE := 0;

AC_MotorRun                : VALUE := 0;
AC_MotorStop               : VALUE := 0;
AC_Stitches                : VALUE := 0;

Status_MotorRun         : BIT := FALSE;
Flag_MotorRun           : BIT := FALSE;
Collect_Time_Before_Sew : BIT := FALSE;
Collect_ReInit_Next_Sew : BIT := FALSE;
Collect_Inside_Sew      : BIT := FALSE;

Disable_SectionInputOutput                       : BIT := FALSE;
Section_Inputs_Motorrun                          : VALUE := 0;
Section_Inputs_MotorStop                         : VALUE := 0;
Section_Outputs_Motorrun                         : VALUE := 0;
Section_Outputs_MotorStop                        : VALUE := 0;
ASI_temp                                         : VALUE := 0;
ASO_temp                                         : VALUE := 0;

Collect_Send_Stack_1                             : BIT := FALSE;
Collect_Send_Stack_2                             : BIT := FALSE;

BigData_ExternalMachine                          : BIT := FALSE;
Status_ServiceExternalMachine                    : VALUE := 0;
Flag_ServiceExternalMachine                      : BIT := FALSE;

ALIAS
TIMER_COLLECT_CYCLE                               : Timer21;//
TIMER_COLLECT_BETWEENSEAMS                        : Timer22;//


COLLECT_SC_SEAM                               : Stitchcounter30;

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Collect_ReInit();




//-------------------------------------------------------------------------------------------------------
//create temporary buffer in RAM
PROCEDURE BigData_Collect_InitArray()
 AC_Stack        := 2;
 ArrayAlloc(ARRAY_COLLECT_NR, LONG, ARRAY_COLLECT_MAX_STACKS, ARRAY_COLLECT_MAX_SECTIONS, ARRAY_COLLECT_MAX_VALUES);
 BigData_Collect_ReInit();  
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Collect_Set(BDCS_Stack : VALUE, BDCS_Section : VALUE, BDCS_Index : VALUE,  BDCS_Value : VALUE)
 ArraySet(ARRAY_COLLECT_NR,BDCS_Stack*1,BDCS_Section*1,BDCS_Index*1,BDCS_Value*1);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Collect_Get(BDCS_Stack : VALUE, BDCG_Section : VALUE, BDCG_Index : VALUE)
 AC_GetVal := ArrayGet(ARRAY_COLLECT_NR,BDCS_Stack*1,BDCG_Section*1,BDCG_Index*1);
END_PROCEDURE





//-------------------------------------------------------------------------------------------------------
PROCEDURE AddSequenceInputs(ASI_Mode : VALUE)
IF (NOT Disable_SectionInputOutput) THEN
 IF (In1) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,1);
 END_IF;
 IF (In2) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,2);
 END_IF;
 IF (In3) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,4);
 END_IF;
 IF (In4) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,8);
 END_IF;
 IF (In5) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,16);
 END_IF;
 IF (In6) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,32);
 END_IF;
 IF (In7) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,64);
 END_IF;
 IF (In8) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,128);
 END_IF;
 IF (In9) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,256);
 END_IF;
 IF (In10) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,512);
 END_IF;

 
 IF (ASI_Mode) THEN
  Section_Inputs_Motorrun := BitOperator(BIT_OPERATOR_OR,Section_Inputs_Motorrun,ASI_temp);
 ELSE
  Section_Inputs_MotorStop := BitOperator(BIT_OPERATOR_OR,Section_Inputs_MotorStop,ASI_temp);
 END_IF;
 
// SetDisplayValue(Section_Inputs_Motorrun,1,0,0);
// SetDisplayValue(Section_Inputs_MotorStop,2,0,0);
// SetDisplayValue(ASI_temp,3,0,0);
END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE AddSequenceOutputs(ASO_Mode : VALUE)
IF (NOT Disable_SectionInputOutput) THEN
 IF (SetOut1) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,1);
 END_IF;
 IF (SetOut2) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,2);
 END_IF;
 IF (SetOut3) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,4);
 END_IF;
 IF (SetOut4) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,8);
 END_IF;
 IF (SetOut5) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,16);
 END_IF;
 IF (SetOut6) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,32);
 END_IF;
 IF (SetOut7) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,64);
 END_IF;
 IF (SetOut8) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,128);
 END_IF;
 IF (SetOut9) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,256);
 END_IF;
 IF (SetOut10) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,512);
 END_IF;
 IF (SetOut11) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,1024);
 END_IF;
 IF (SetOut12) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,2048);
 END_IF;
 IF (SetOut13) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,4096);
 END_IF;

 
 IF (ASO_Mode) THEN
  Section_Outputs_Motorrun := BitOperator(BIT_OPERATOR_OR,Section_Outputs_Motorrun,ASO_temp);
 ELSE
  Section_Outputs_MotorStop := BitOperator(BIT_OPERATOR_OR,Section_Outputs_MotorStop,ASO_temp);
 END_IF;
 
// SetDisplayValue(Section_Outputs_Motorrun,1,0,0);
// SetDisplayValue(Section_Outputs_MotorStop,2,0,0);
// SetDisplayValue(ASO_temp,3,0,0);

END_IF;
END_PROCEDURE





//-------------------------------------------------------------------------------------------------------
//Seam finished -> toggle
PROCEDURE BigData_Collect_ToggleStack()
//SetBeepShort();
IF (AC_Stack = 1) THEN
 AC_Stack := 2;
ELSE
 AC_Stack := 1;
END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//restart timer
//PROCEDURE BigData_Collect_Init_BETWEENSEAMS()
// ClearTimer(TIMER_COLLECT_BETWEENSEAMS);
// SetTimer(TIMER_COLLECT_BETWEENSEAMS, MAX_COLLECT_TIMER_OFFSET);
//END_PROCEDURE
//-------------------------------------------------------------------------------------------------------
//sum of the delta time
//PROCEDURE BigData_Collect_Cont_BETWEENSEAMS()
//// IF (TimerIsRunning(TIMER_COLLECT_BETWEENSEAMS)) THEN
////  AC_BETWEENSEAMS := MAX_COLLECT_TIMER_OFFSET - GetTimer(TIMER_COLLECT_BETWEENSEAMS);
//// ELSE
////  AC_BETWEENSEAMS := MAX_COLLECT_TIMER_OFFSET;
//// END_IF;
// 
// AC_BETWEENSEAMS := AC_BETWEENSEAMS + (MAX_COLLECT_TIMER_OFFSET - GetTimer(TIMER_COLLECT_BETWEENSEAMS));
// BigData_Collect_Init_BETWEENSEAMS();
//END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//init power on
//PROCEDURE BigData_Collect_Init()
// AC_Stack        := 2;
//END_PROCEDURE

//-------------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------------
//init new seam
PROCEDURE BigData_Collect_InitSection()
 AC_MotorRun     := 0;
 AC_MotorStop    := 0;
 
 FastCounter     := 0;
 
 ClearStitchcounter(COLLECT_SC_SEAM);
 SetStitchcounter(COLLECT_SC_SEAM,MAX_COLLECT_SEAM_STITCH);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//init new seam
PROCEDURE BigData_Collect_ReInit()

 AC_Section_Counter     := 1;
 AC_GetVal              := 1;
 AC_BETWEENSEAMS_TEMP   := 0;
 Status_MotorRun        := FALSE;
 Flag_MotorRun          := FALSE;
 BigData_Collect_InitSection();
 BigData_Collect_ToggleStack();
// BigData_Collect_Init_BETWEENSEAMS();
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE Collect_Next_Section()
IF (AC_Section_Counter <= ARRAY_COLLECT_MAX_SECTIONS) THEN
 IF (BigData_ExternalMachine) THEN
  AC_Stitches := FastCounter;//fast counting (=4) In1
 ELSE
  AC_Stitches := MAX_COLLECT_SEAM_STITCH - GetStitchcounter(COLLECT_SC_SEAM);
 END_IF;

 BigData_Collect_Set(AC_Stack*1, AC_Section_Counter*1, AC_RUN_TIME,     AC_MotorRun*1); 
 BigData_Collect_Set(AC_Stack*1, AC_Section_Counter*1, AC_STOP_TIME,    AC_MotorStop*1); 
 BigData_Collect_Set(AC_Stack*1, AC_Section_Counter*1, AC_STITCHES,     AC_Stitches*1); 
 BigData_Collect_Set(AC_Stack*1, AC_Section_Counter*1, AC_RUN_INPUTS,   Section_Inputs_Motorrun*1); 
 BigData_Collect_Set(AC_Stack*1, AC_Section_Counter*1, AC_STOP_INPUTS,  Section_Inputs_MotorStop*1); 
 BigData_Collect_Set(AC_Stack*1, AC_Section_Counter*1, AC_RUN_OUTPUTS,  Section_Outputs_Motorrun*1); 
 BigData_Collect_Set(AC_Stack*1, AC_Section_Counter*1, AC_STOP_OUTPUTS, Section_Outputs_MotorStop*1); 


 BigData_Collect_InitSection();
 AC_Section_Counter := AC_Section_Counter + 1;
 
END_IF; 
END_PROCEDURE

//***************************************************************************
FUNCTION Fkt_MotorRun() : VALUE
 Fkt_MotorRun := 0;

 IF (MotorRun OR (GetSpeed() > 50)) THEN
  Fkt_MotorRun := 1;
 END_IF; 
 
 IF (BigData_ExternalMachine) THEN 
  IF (Flag_ServiceExternalMachine = OFF) THEN
   Fkt_MotorRun := 1;
  END_IF;
 END_IF; 
END_FUNCTION

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Collect_SewInformation(BDCSI_DeltaTime : VALUE)
//calculate delta time
 BDCSI_DeltaTime := 0;
 IF (TimerIsRunning(TIMER_COLLECT_BETWEENSEAMS)) THEN
  BDCSI_DeltaTime := MAX_COLLECT_TIMER_OFFSET - GetTimer(TIMER_COLLECT_BETWEENSEAMS);
 END_IF;
 ClearTimer(TIMER_COLLECT_BETWEENSEAMS);
 SetTimer(TIMER_COLLECT_BETWEENSEAMS, MAX_COLLECT_TIMER_OFFSET);
// IF (BDCSI_DeltaTime > 25) THEN//must be around 10ms cycle time
//  SetBeepShort();
//  SetDisplayValue(BDCSI_DeltaTime*1,1,0,0);
// END_IF;
 
//calculate time before sewing 
 IF (Collect_Time_Before_Sew) THEN
  AC_BETWEENSEAMS_TEMP := AC_BETWEENSEAMS_TEMP + BDCSI_DeltaTime;
 END_IF;
 
//Detect seam end 
 IF (Collect_ReInit_Next_Sew) THEN
  AC_BETWEENSEAMS_LAST_SEAM := AC_BETWEENSEAMS_TEMP;
  Collect_Next_Section();
  IF (AC_Stack = 2) THEN
   AC_TWO_Section := AC_Section_Counter;
  ELSE
   AC_ONE_Section := AC_Section_Counter;
  END_IF;
  BigData_Collect_ReInit();//has to be last function
  
 END_IF;

//calculate motor run and motor stop time inside seam
 Status_MotorRun := FALSE;
 IF (Collect_Inside_Sew) THEN
  IF (Fkt_MotorRun())  THEN
   Status_MotorRun := TRUE;
  ELSE
   IF (BeginBt OR EndBt) THEN
    Status_MotorRun := TRUE;
   END_IF;
  END_IF;
  IF (Status_MotorRun) THEN
//   SetOut5 := ON;
   AC_MotorRun := AC_MotorRun + BDCSI_DeltaTime;  
   AddSequenceInputs(1);
   AddSequenceOutputs(1);
  ELSE
//   SetOut5 := OFF;
   AC_MotorStop := AC_MotorStop + BDCSI_DeltaTime;  
   AddSequenceInputs(0);
   AddSequenceOutputs(0);
  END_IF; 
 END_IF;
 
// IF (Status_MotorRun) THEN
//  SetDisplayValue(1,1,0,0);
// ELSE
//  SetDisplayValue(0,1,0,0);
// END_IF;
// IF (Fkt_MotorRun()) THEN
//  SetDisplayValue(1,2,0,0);
// ELSE
//  SetDisplayValue(0,2,0,0);
// END_IF;
// SetDisplayValue(AC_MotorRun,3,0,0);
 
//detect next section
 IF (Status_MotorRun AND NOT Flag_MotorRun) THEN
  Collect_Next_Section();
  Flag_MotorRun := TRUE;
 END_IF; 
 IF (NOT Status_MotorRun AND Flag_MotorRun) THEN
  Flag_MotorRun := FALSE;
 END_IF; 
 
 
 
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
END_UNIT
