UNIT BIGDATA
	SYSTEM FP220AE

//-------------------------------------------------------------------------------------------------------
//
// Units
//
//-------------------------------------------------------------------------------------------------------
USES "Units\U_Barcode"
USES "Units\Unit_BigData_RxTx"

//-------------------------------------------------------------------------------------------------------
//
// CONST/VAR/ALIAS
//
//-------------------------------------------------------------------------------------------------------
CONST


MAX_TIMER_OFFSET                                 : VALUE := 10000000;//=10000sec

PARA_TASTE_F1                                    : VALUE := 293;
PARA_TASTE_F2                                    : VALUE := 294;
        
SEAM_STITCH_MAX                                  : VALUE := 20000;


TASKTIMER_SECTION_MOTORRUN                       : VALUE := 1;
TASKTIMER_SECTION_MOTORSTOP                      : VALUE := 2;

TASKTIME_OFFSET                                  : VALUE := 100000;

//Values for DoubleOperation()
//OP_DIV                                           : VALUE := 1;
//OP_MUL                                           : VALUE := 2;
//OP_ADD                                           : VALUE := 3;
//OP_SUB                                           : VALUE := 4;
//OP_RET_H                                         : VALUE := 10;
//OP_RET_L                                         : VALUE := 11;

//Values for BigData_SewInformation
SEWINFO_STANDARD                                 : VALUE := 1;
SEWINFO_SHORT                                    : VALUE := 2;
SEWINFO_SPECIAL_BACKTACK                         : VALUE := 3;


VAR
BigData_Enable                                   : VALUE := 0;
Merker_VarioButtons                              : VALUE := 0;
Ablauf_Seam_Data_Manager                         : VALUE := 0;
BigData_SendSewInformationInput                  : VALUE := 0;
Flag_StartMotorRunAfterStop                      : BIT := FALSE;
Flag_Bt                                          : BIT := FALSE;
bTrimming                                        : BIT := FALSE;
Flag_AddSequenceInfo                             : BIT := FALSE;
IsDA321                                          : BIT := FALSE;
Merker_EXTERNAL_MACHINE_START                    : BIT := FALSE;
Display_SymRunBlockage                           : BIT := FALSE;
Flag_SymRunBlockage                              : BIT := FALSE;
flag_SetWaitForSeamBegin                         : BIT := FALSE;
flag_BigData_SetWaitForSeamBegin                 : BIT := FALSE;
flag_Main_SetWaitForSeamBegin                    : BIT := FALSE;
flag_SetWaitForSeamEnd                           : BIT := FALSE;
flag_BigData_SetWaitForSeamEnd                   : BIT := FALSE;
flag_Main_SetWaitForSeamEnd                      : BIT := FALSE;
Status_BigData_SeamManager                       : VALUE := 0;
Merker_Seam_Data_Manager                         : VALUE := 0;
Status_SendSewInformation_Trigger                : VALUE := 0;
Status_ExternalMachine                           : VALUE := 0;

//-------------------------------------------------------------------------------------------------------
PROCEDURE Seam_Data_Mng_Init();



//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------
PROCEDURE Barcode_Init()
NewString(STRING_BARCODE,STRING_BARCODE_LENGTH);
ReadDeviceProductString(BARCODE_COM_NR,STRING_BARCODE);
bBarcodeReaderIsPresent := FALSE;
IF (StringLen(STRING_BARCODE) > 2) THEN
 SetDisplayText(STRING_BARCODE,5,0,0);
 bBarcodeReaderIsPresent := TRUE;
ELSE 
 SetDisplayText("No Reader found",5,0,0);
END_IF;
 
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE SetServiceCall()
 VAL_SERVICE_NUMBER := StringToValue(STRING_BARCODE);
 BigData_SendString(BIGDATA_ID_SEND_SERVICE_CALL);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE SetUserID()
// IF (Is_UserID_Set()) THEN    
//  BigData_SendString(BIGDATA_ID_SEND_OPERATOR_ID_LOGOUT);
//  VAL_USER_ID_1 := 0;
//  VAL_USER_ID_2 := 0;
//  VAL_USER_ID_3 := 0;
// ELSE    
  strupr(STRING_BARCODE);//alle buchtaben mssen gro sein
  
  //erste 4 Stellen in dez
  StringCopy(STRING_NAME_3,"0x");
  StringXCopy(STRING_NAME_2,STRING_BARCODE,0,4);
  StringAppend(STRING_NAME_3,STRING_NAME_2);
  dummy := HexStringToDez(STRING_NAME_3);
  VAL_USER_ID_1 := dummy;
  
  //mittlere 4 Stellen in dez
  StringCopy(STRING_NAME_3,"0x");
  StringXCopy(STRING_NAME_2,STRING_BARCODE,4,4);
  StringAppend(STRING_NAME_3,STRING_NAME_2);
  dummy := HexStringToDez(STRING_NAME_3);
  VAL_USER_ID_2 := dummy;
  
  //letzte 2 Stellen in dez
  StringCopy(STRING_NAME_3,"0x");
  StringXCopy(STRING_NAME_2,STRING_BARCODE,8,2);
  StringAppend(STRING_NAME_3,STRING_NAME_2);
  dummy := HexStringToDez(STRING_NAME_3);
  VAL_USER_ID_3 := dummy; 
      
  BigData_SendString(BIGDATA_ID_SEND_OPERATOR_ID_LOGIN);
// END_IF;
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------Nahtanfang
//Bevor Nahtanfang kommt wird alles initialisiert
//PROCEDURE SewInformation_Init()
////Nahtinformationen nullen
//
//
//// Section_GesamtStitchCount        := 0;
//
// 
// //Ablauf_StitchCount_Task          := 1;
//
// Value_SEAM_END_INPUT := GetParameter(PARA_SEAM_END_INPUT);
//
// Flag_StartMotorRunAfterStop := TRUE;
// Flag_Bt                     := FALSE; 
////SectionInfos nullen 
//// SequenzSeam_StopCount            := 0; 
// 
////Timer fr MotorRun und MotorStop
// ClearTimer(TIMER_MOTORSTOP);
// SetTimer(TIMER_MOTORSTOP, MAX_TIMER_OFFSET);  
// 
////Stichzhler fr Sections 
// ClearStitchcounter(STITCHCOUNTER_SEAM);
// SetStitchcounter(STITCHCOUNTER_SEAM,SEAM_STITCH_MAX);
//// Section_MerkerStitchCount := SEAM_STITCH_MAX;
// 
//// InitSequence();
//// Section_RunTime           := 0;
//// Section_StopTime          := 0;
// Seam_Stopp_Counter        := 0;
//// Section_GesamtStitchCount := 0;
//END_PROCEDURE
//



//-------------------------------------------------------------------------------------------------------
//all system variables which are used by bigdata and maybe user software have to handle here
PROCEDURE BigData_SysIO_Manager()
IF (flag_BigData_SetEnableFpPedal OR flag_Main_SetEnableFpPedal) THEN
  SetEnableFpPedal := ON;
ELSE
 SetEnableFpPedal := OFF;
END_IF;
IF (flag_BigData_SetDisablePedal OR flag_Main_SetDisablePedal) THEN
  SetDisablePedal := ON;
ELSE
 SetDisablePedal := OFF;
END_IF;
IF (flag_BigData_SetRunBlockage OR flag_Main_SetRunBlockage) THEN
  SetRunBlockage := ON;
ELSE
 SetRunBlockage := OFF;
END_IF;
IF (flag_BigData_SetStopNoPosition OR flag_Main_SetStopNoPosition) THEN
 SetStopNoPosition := ON;
ELSE
 SetStopNoPosition := OFF;
END_IF;
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
//Seam Manager - to handle operations before seambegin and after seamend
//in a task to save time to detect seam start
//PROCEDURE BigData_SeamManager()
TASK BigDataTask()
SetTaskTime(5);

Collect_Time_Before_Sew := FALSE;
Collect_ReInit_Next_Sew := FALSE; 
Collect_Inside_Sew      := FALSE; 

 SELECT (Status_BigData_SeamManager) OF
    
  CASE 1://set SetWaitForSeamBegin
   flag_SetWaitForSeamBegin   := OFF;
   SetWaitForSeamBegin        := ON;
   Status_BigData_SeamManager := 2;
Collect_Time_Before_Sew := TRUE;
   
  CASE 2://wait until seam wants to be started by pedal
Collect_Time_Before_Sew := TRUE;
   IF (WaitForSeamBegin) THEN
    flag_SetWaitForSeamBegin   := ON;
    Status_BigData_SeamManager := 3;
   END_IF; 
  
  CASE 3://wait until the requests are reset
Collect_Time_Before_Sew := TRUE;
   IF (NOT flag_BigData_SetWaitForSeamBegin) THEN
   IF (NOT flag_Main_SetWaitForSeamBegin) THEN
    flag_SetWaitForSeamEnd         := OFF;
    flag_SetWaitForSeamBegin       := OFF;
    SetWaitForSeamEnd   := ON;
    SetWaitForSeamBegin := OFF;
//SetOut5 := ON;  
    Status_BigData_SeamManager := 4;
   END_IF; 
   END_IF; 
     
  CASE 4://wait until seam wants to be end by pedal
Collect_Inside_Sew := TRUE; 
   IF (WaitForSeamEnd) THEN
    flag_SetWaitForSeamEnd := ON;
    Status_BigData_SeamManager := 5;
   END_IF; 

  CASE 5://wait until the requests are reset
   IF (NOT flag_BigData_SetWaitForSeamEnd) THEN
   IF (NOT flag_Main_SetWaitForSeamEnd) THEN
    flag_SetWaitForSeamEnd         := OFF;
    flag_SetWaitForSeamBegin       := OFF;
Collect_ReInit_Next_Sew := TRUE; 
    SetWaitForSeamBegin := ON;
    SetWaitForSeamEnd   := OFF;
    
//SetOut5 := OFF;  

    Status_BigData_SeamManager := 1;
   END_IF; 
   END_IF; 
  
  CASE 100:
   dummy := dummy;
  
  ELSE:
   Status_BigData_SeamManager := 1; 
   
 END_SELECT;

//SetDisplayValue(Status_SendSewInformation_Trigger,1,0,0);

//Special modes to send seam data
   IF ( (BigData_SendSewInformationWhenPedal0 = ON) OR (Value_SEAM_END_INPUT > 0) ) THEN
    SELECT (Status_SendSewInformation_Trigger) OF
     CASE 0:    
      IF (Fkt_MotorRun()) THEN
       Status_SendSewInformation_Trigger := 1;
      ELSE 
       Collect_Time_Before_Sew := TRUE;
      END_IF;
     CASE 1:
      Collect_Inside_Sew := TRUE; 
      IF ((BigData_SendSewInformationWhenPedal0 = ON) AND Pedal0) THEN
       Status_SendSewInformation_Trigger := 10;
      END_IF;
      IF (Value_SEAM_END_INPUT <> 0) THEN
       BigData_SendSewInformationInput := IsSeamInputSet(0);
       IF (BigData_SendSewInformationInput > 0) THEN
        Status_SendSewInformation_Trigger := 10;
       END_IF;
      END_IF;
    CASE 10:
      IF (Fkt_MotorRun()) THEN
       Collect_Inside_Sew := TRUE; 
      ELSE
       Collect_ReInit_Next_Sew := TRUE; 
       Status_SendSewInformation_Trigger := 0;
      END_IF;      
                  
    END_SELECT;
   END_IF;
   
   
//SetDisplayValue(Status_ExternalMachine,1,0,0);
//SetDisplayValue(FastCounter*1,2,0,0);
////IF (Flag_ServiceExternalMachine) THEN
////SetDisplayValue(1,3,0,0);
////ELSE
////SetDisplayValue(0,3,0,0);
////END_IF;   
//SetDisplayValue(AC_MotorRun,3,0,0);
//SetDisplayValue(AC_MotorStop,3,0,0);

   
   
   IF (BigData_ExternalMachine) THEN
    SELECT (Status_ServiceExternalMachine) OF
     CASE 0:
      IF (IN_EXTERNAL_MACHINE_SERVICE) THEN
       IF (Flag_ServiceExternalMachine) THEN
        Flag_ServiceExternalMachine := OFF;
       ELSE
        Flag_ServiceExternalMachine := ON;
       END_IF; 
       Status_ServiceExternalMachine := Status_ServiceExternalMachine + 1;    
      END_IF;
     CASE 1:
      IF (NOT IN_EXTERNAL_MACHINE_SERVICE) THEN
       Status_ServiceExternalMachine := Status_ServiceExternalMachine + 1;    
      END_IF;
     CASE 2:
       Status_ServiceExternalMachine := 0;    
       
    END_SELECT;
    SELECT (Status_ExternalMachine) OF
     CASE 0://init   
       Collect_Time_Before_Sew := TRUE;
//      IF(IN_EXTERNAL_MACHINE_START)THEN 
       IRQInXXFunktion (In1,1,4,0);//fast counting (=4) In1
       Status_ExternalMachine := Status_ExternalMachine + 1;
//      END_IF; 
     CASE 1://wait seam begin    
      IF (IN_EXTERNAL_MACHINE_START) THEN 
       Status_ExternalMachine := Status_ExternalMachine + 1;
      ELSE
       Collect_Time_Before_Sew := TRUE;
      END_IF; 
     CASE 2://wait seam end
      IF (IN_EXTERNAL_MACHINE_END) THEN
       Collect_ReInit_Next_Sew := TRUE; 
       Status_ExternalMachine := Status_ExternalMachine + 1;
      ELSE
       Collect_Inside_Sew := TRUE; 
      END_IF; 
     CASE 3://end
      //FastCounter := 0;
      Status_ExternalMachine := 0;
       
    END_SELECT;
   END_IF;


//check is previous sem is not send
/*
IF (Collect_ReInit_Next_Sew) THEN
 IF (AC_Stack = 2) THEN
  Collect_Send_Stack_2 := TRUE;
 ELSE
  Collect_Send_Stack_1 := TRUE;
 END_IF;
 IF (Collect_Send_Stack_1 AND Collect_Send_Stack_2) THEN
  SetBeepShort();
 END_IF;
END_IF;
*/
BigData_Collect_SewInformation(0);

IF (Collect_ReInit_Next_Sew) THEN 
 SELECT (BigData_SewInformation) OF
  CASE SEWINFO_STANDARD:
   BigData_SendString(BIGDATA_ID_SEND_SEW_INFORMATION);
  CASE SEWINFO_SHORT:
   BigData_SendString(BIGDATA_ID_SEND_SHORT_SEW_INFORMATION);
  CASE SEWINFO_SPECIAL_BACKTACK: 
   BigData_SendString(BIGDATA_ID_SEND_SHORT_SEW_INFORMATION);
 END_SELECT;     
 bTrimming := TRUE;
END_IF;

 
 BreakTask();
END_TASK
//END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
FUNCTION BigData_WaitForSeamBegin() : VALUE
 BigData_WaitForSeamBegin := 0;
 IF (flag_SetWaitForSeamBegin) THEN
  BigData_WaitForSeamBegin := 1;
 END_IF;
END_FUNCTION


//-------------------------------------------------------------------------------------------------------
FUNCTION BigData_WaitForSeamEnd() : VALUE
 BigData_WaitForSeamEnd := 0;
 IF (flag_SetWaitForSeamEnd) THEN
  BigData_WaitForSeamEnd := 1;
 END_IF;
END_FUNCTION

//-------------------------------------------------------------------------------------------------------
//Basiswert der Variablen nach dem Einschalten
PROCEDURE InitVars()
dummy                                            := 0;
Ablauf_Menu                                      := 0;
Merker_VarioButtons                              := 0;
TempVal1                                         := 0;
Anzeige_Naht_Text_neu                            := 0;
Anzeige_Naht_Text_alt                            := 0;
Ablauf_Seam_Data_Manager                         := 0;
Seam_Time_Second_Counter                         := 0;
Seam_Stitch_Counter                              := 0;
Seam_Stopp_Counter                               := 0;

SetParameter(PARA_TASTE_F1,0);
SetParameter(PARA_TASTE_F2,0);

DevSendStringNoAck := TRUE;//disable acknolage of devsendstring commands
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//Nach PowerOn werden die letzten Werte geladen
PROCEDURE PieceCounter_PowerOn()
 PieceCounter_COUNT_MAX := GetParameter(PARA_PIECECOUNTER_COUNT_MAX);
 PieceCounter_COUNT_Act := GetParameter(PARA_PIECECOUNTER_COUNT_Act);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//Piececounter. Bei jedem Abschneiden wird der Zhler erhht. Bei Erreichen des Maximalwerts wird eine
//Nachricht an den PC gesendet un der Zhler auf 0 gesezt
PROCEDURE PieceCounter_Manager()
IF (NOT Disable_PieceCounter) THEN
 IF (PieceCounter_COUNT_MAX) THEN//Ist Piececounter aktiv?
  IF (bTrimming) THEN//Wurde abgeschnitten?
   bTrimming := FALSE;
   IF (PieceCounter_COUNT_Act < PieceCounter_COUNT_MAX - 1) THEN//Ist Maximalwert schon erreicht?
    PieceCounter_COUNT_Act := PieceCounter_COUNT_Act + 1;
   ELSE//Maximalwert ist erreicht -> Nachricht senden, init des Zhlers
    PieceCounter_COUNT_Act := 0;
    BigData_SendString(BIGDATA_ID_SEND_PIECECOUNTER_READY_0);   
    //SetBeepShort();
   END_IF; 
   SetParameter(PARA_PIECECOUNTER_COUNT_Act,PieceCounter_COUNT_Act);
  END_IF;
// CreateDisplay();
// SetDisplayValue(PieceCounter_COUNT_Act,1,0,0);
// SetDisplayValue(PieceCounter_COUNT_MAX,2,0,0);
 END_IF;
END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//Nach PowerOn werden die letzten Werte geladen
PROCEDURE ServiceCounter_PowerOn()
 ServiceCounter_Startwert_1 := GetParameter(PARA_SERVICECOUNTER_STARTWERT_1);
 ServiceCounter_Mode_1      := GetParameter(PARA_SERVICECOUNTER_MODE_1);
 ServiceCounter_Act_1       := GetParameter(PARA_SERVICECOUNTER_ACT_1);
 ServiceCounter_Startwert_2 := GetParameter(PARA_SERVICECOUNTER_STARTWERT_2);
 ServiceCounter_Mode_2      := GetParameter(PARA_SERVICECOUNTER_MODE_2);
 ServiceCounter_Act_2       := GetParameter(PARA_SERVICECOUNTER_ACT_2);
 ServiceCounter_Startwert_3 := GetParameter(PARA_SERVICECOUNTER_STARTWERT_3);
 ServiceCounter_Mode_3      := GetParameter(PARA_SERVICECOUNTER_MODE_3);
 ServiceCounter_Act_3       := GetParameter(PARA_SERVICECOUNTER_ACT_3);
 ServiceCounter_Startwert_4 := GetParameter(PARA_SERVICECOUNTER_STARTWERT_4);
 ServiceCounter_Mode_4      := GetParameter(PARA_SERVICECOUNTER_MODE_4);
 ServiceCounter_Act_4       := GetParameter(PARA_SERVICECOUNTER_ACT_4);
 ServiceCounter_Startwert_5 := GetParameter(PARA_SERVICECOUNTER_STARTWERT_5);
 ServiceCounter_Mode_5      := GetParameter(PARA_SERVICECOUNTER_MODE_5);
 ServiceCounter_Act_5       := GetParameter(PARA_SERVICECOUNTER_ACT_5);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//ServiceCounter. Es wird berprft ob der ServiceCounter abgelaufen ist und eine entsprechende Nachricht gesendet.
//Danach wird der ServiceCounter automatisch wieder gestartet
FUNCTION ServiceCounter_Manager(SCM_ID : VALUE, SCM_Startwert : VALUE, SCM_Mode : VALUE, SCM_Act : VALUE, SCM_Save : VALUE) : VALUE
 IF (SCM_Startwert*1) THEN//Ist Counter aktiv?
  SELECT (SCM_Mode*1) OF//Zeit oder Stiche vom aktuellen Wert abziehen
   CASE SERVICECOUNTER_MODE_TIMER:
    IF (ServiceCounter_ExecuteTime > 0) THEN
       SCM_Act := GetParameter(PARA_SERVICECOUNTER_SEC_1 + SCM_ID - 1) + ServiceCounter_ExecuteTime;//Aktueller Wert + gesammelte Zeit
       IF (SCM_Act >= 3600) THEN//Ist schon eine Stunde um?
        SCM_Act := 0;//Sekunden wieder auf NULL setzen
        SetParameter(PARA_SERVICECOUNTER_SEC_1 + SCM_ID - 1, SCM_Act*1);//Sekunden speichern
        SCM_Act := GetParameter(PARA_SERVICECOUNTER_ACT_1 + SCM_ID - 1);//Aktuellen Stundenwert holen
        IF (SCM_Act >= 1) THEN
         SCM_Act := SCM_Act - 1;//eine Stunde abziehen
        ELSE
         SetParameter(PARA_SERVICECOUNTER_ACT_1 + SCM_ID - 1, SCM_Startwert*1);
         SELECT (SCM_ID*1) OF//Abschicken der Nachricht
          CASE 1:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_0);   
          CASE 2:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_1);   
          CASE 3:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_2);   
          CASE 4:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_3);   
          CASE 5:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_4);   
         END_SELECT;
        END_IF;
       ELSE
        SetParameter(PARA_SERVICECOUNTER_SEC_1 + SCM_ID - 1, SCM_Act*1);//neuen Wert speichern
       END_IF;
//       CreateDisplay();
//       SetDisplayValue(ServiceCounter_ExecuteTime,1,0,0);
//       SetDisplayValue(GetParameter(PARA_SERVICECOUNTER_SEC_1 + SCM_ID - 1),2,0,0);
//       SetDisplayValue(SCM_Act*1,3,0,0);
    END_IF;
   CASE SERVICECOUNTER_MODE_COUNTER:
    IF (ServiceCounter_ExecuteCount) THEN
     SCM_Act := SCM_Act - ServiceCounter_ExecuteCount;
     SCM_Save := 1;
    END_IF;
  END_SELECT;
  IF (SCM_Act <= 0) THEN//Wenn der aktuelle Wert kleiner 0 ist, ist der Zhler abglaufen
   SCM_Act := SCM_Startwert*1;//ReInit des aktuelle Wert
//   SetBeepShort();
   SELECT (SCM_ID*1) OF//Abschicken der Nachricht
    CASE 1:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_0);   
    CASE 2:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_1);   
    CASE 3:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_2);   
    CASE 4:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_3);   
    CASE 5:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_4);   
   END_SELECT;
   SCM_Save := 1;
  END_IF;
  IF (SCM_Save) THEN//Bei nderung des Wertes wird auch gespeichert
   SELECT (SCM_ID*1) OF
    CASE 1:     SetParameter(PARA_SERVICECOUNTER_ACT_1,       SCM_Act*1);
    CASE 2:     SetParameter(PARA_SERVICECOUNTER_ACT_2,       SCM_Act*1);   
    CASE 3:     SetParameter(PARA_SERVICECOUNTER_ACT_3,       SCM_Act*1);  
    CASE 4:     SetParameter(PARA_SERVICECOUNTER_ACT_4,       SCM_Act*1); 
    CASE 5:     SetParameter(PARA_SERVICECOUNTER_ACT_5,       SCM_Act*1);  
   END_SELECT;
  END_IF;
//  CreateDisplay();
//  SetDisplayValue(GetParameter(PARA_SERVICECOUNTER_SEC_1),1,0,0);
//  SetDisplayValue(GetParameter(PARA_SERVICECOUNTER_ACT_1),2,0,0);
//  SetDisplayValue(SCM_ID*1,3,0,0);
 END_IF;
 ServiceCounter_Manager := SCM_Act*1;//Aktuellen Wert immer zurckgeben
END_FUNCTION

//-------------------------------------------------------------------------------------------------------
//
// Main Functions
//
//-------------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------------
//TASK HilfsTask()
// IF (BeginBt) THEN
//  SetOut1 := ON;
// ELSE 
//  SetOut1 := OFF;
// END_IF;
// IF (Bt) THEN
//  SetOut2 := ON;
// ELSE 
//  SetOut2 := OFF;
// END_IF;
// IF (EndBt) THEN
//  SetOut3 := ON;
// ELSE 
//  SetOut3 := OFF;
// END_IF;
// IF (SeamFreeRun) THEN
//  SetOut4 := ON;
// ELSE 
//  SetOut4 := OFF;
// END_IF;
// IF (Position1) THEN
//  SetOut5 := ON;
// ELSE 
//  SetOut5 := OFF;
// END_IF;
// IF (Fkt_MotorRun()) THEN
//  SetOut6 := ON;
// ELSE 
//  SetOut6 := OFF;
// END_IF;
// IF (Ablauf_Seam_Data_Manager = 2) THEN
//  SetOut7 := ON;
// ELSE 
//  SetOut7 := OFF;
// END_IF;
// IF (Flag_AddSequenceInfo) THEN
//  SetOut8 := ON;
// ELSE 
//  SetOut8 := OFF;
// END_IF; 
// BreakTask();
//END_TASK
//
////-------------------------------------------------------------------------------------------------------
//PROCEDURE Fkt_Debug_Signale_Active()
//IF (Val_DEBUG_SIGNALS_ACTIVE) THEN
// SetDisableOutM1 := ON;
// SetDisableOutM2 := ON;
// SetDisableOutM3 := ON;
// SetDisableOutM4 := ON;
// SetDisableOutM5 := ON;
// SetDisableOutM6 := ON;
// SetDisableOutM7 := ON;
// SetDisableOutM8 := ON;
// START HilfsTask;
//END_IF;
//END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
//Debug routine to download compiler software by IF232 cable and set all neccessary standard parameters
//to download compiler software you have to switch In7=ON until download is finished
PROCEDURE Fkt_Debug_Active()
// IF (Val_DEBUG_ACTIVE OR Val_DEBUG_SIGNALS_ACTIVE) THEN
//  SetDisplayText("!!! DEBUG !!!",5,0,0);
//  Waitms(500);
// ELSE
  //SetDisplayValue(VERSIONSNUMMER,1,0,0);
  //SetDisplayText("BigData",3,0,0);
  DisplayCharacterSet("v",1,0);
  DisplayValuePositionSet(BIGDATA_VERSIONSNUMMER,2,2);
  DisplayCharacterSet("BigData",5,0);  
// END_IF; 
 WHILE (USBEnumerationIsActive)
  BreakTask();
 END_WHILE;

 IF (Val_DEBUG_ACTIVE) THEN
  IF (In7) THEN
   SetDisplayText("In7  ON",1,0,0);
   SetParameter(413,1);  
   IF (ParaExist(280)) THEN//Only for DA321
    SetParameter(280,1000);
    SetParameter(290,20);
   ELSE
    SetParameter(290,5);
   END_IF;
   SetParameter(111,1500);
   SetParameter(PARA_BIGDATA_MODE,BIGDATA_MODE_5);
   SetParameter(799,222);
   SetParameter(413,6);
   SetParameter(241,0);
   SetParameter(270,0);
   WHILE (In7)
   END_WHILE;
   CreateDisplay();
//   Fkt_Debug_Signale_Active();
  END_IF;
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Begin()//

BigData_Collect_InitArray();

 Val_DEBUG_ACTIVE := FALSE;
//IF (GetParameter(PARA_DEBUG_ACTIVE) = 0) THEN
// Val_DEBUG_ACTIVE := FALSE;
//ELSE
// Val_DEBUG_ACTIVE := TRUE;
//END_IF;
//IF (GetParameter(PARA_DEBUG_SIGNALS_ACTIVE) = 0) THEN
// Val_DEBUG_SIGNALS_ACTIVE := FALSE;
//ELSE
// Val_DEBUG_SIGNALS_ACTIVE := TRUE;
//END_IF;

CreateDisplay();
flag_BigData_SetEnableFpPedal := ON;

Fkt_Debug_Active();

IF (ParaExist(280)) THEN//Only for DA321
 IsDA321 := TRUE;
END_IF;

BigData_DataMode    := GetParameter(PARA_BIGDATA_MODE);

IF (BigData_DataMode) THEN
 SetDisplayText("Init Strings",5,0,0);
 NewString(STRING_CODE,             SIZE_STRING_TEMP);
 NewString(STRING_CODE2,            SIZE_STRING_TEMP);
 NewString(STRING_Tx,               SIZE_STRING_TEMP); 
 //NewString(STRING_Rx,               SIZE_STRING_TEMP);
 NewString(STRING_TEMP1,            SIZE_STRING_TEMP);
 NewString(STRING_BigDataString,    SIZE_STRING_TEMP);
 NewString(STRING_TEMP2,            SIZE_STRING_TEMP);
 NewString(STRING_OPERATOR,         SIZE_STRING_TEMP);
 
 NewString(STRING_NAME_1,           SIZE_STRING_TEMP);
 NewString(STRING_NAME_2,           SIZE_STRING_TEMP);
 NewString(STRING_NAME_3,           SIZE_STRING_TEMP);
 NewString(STRING_NAME_4,           SIZE_STRING_TEMP);
 
 NewString(STRING_BARCODE,          STRING_BARCODE_LENGTH);
 
 SetDisplayText("Init ID",5,0,0);
  VAL_PARA_MACHINE_ID := GetParameter(PARA_MACHINE_ID1);//F799
  IF (ParaExist(PARA_MACHINE_ID2)) THEN
   IF (GetParameter(PARA_MACHINE_ID2) > 0) THEN
    VAL_PARA_MACHINE_ID := GetParameter(PARA_MACHINE_ID2);//F907
   END_IF;
  END_IF;
  BigData_Enable      := GetSystemInfo(SYSTEMINFO_BigData_SoftwareEnable);
  IF (BigData_Enable) THEN
   Ablauf_BigData_Cont := 500;    
  ELSE
   Ablauf_BigData_Cont := 1;
  END_IF; 
// SetDisplayText("Init Version",5,0,0);
//  SetParameter(PARA_VERSION,VERSIONSNUMMER);
//  SetParameter(PARA_EFKA_PROJEKTNUMMER,EFKA_PROJEKTNUMMER);
  SetParameter(PARA_BIGDATA_VERSION,BIGDATA_VERSIONSNUMMER);
 SetDisplayText("Init Array",5,0,0);
  NewBigDataArray(); 
 SetDisplayText("Init Variables",5,0,0);
  InitVars();//BRC disable
  SetParameter(412,1);//Baudrate 9600
  SetParameter(413,6);//control box broadcast 6=BigData
  SetParameter(414,1);//control box device adress
 SetDisplayText("Init Dongle",5,0,0);
  dummy := GetSystemInfo(SYSTEMINFO_Dongle_Init);
  dummy := GetSystemInfo(SYSTEMINFO_Dongle_Get);
  
 //SetDisplayText("Get  Sysinfo",5,0,0);
 //DataDump_AmoutOfData          := GetSystemInfo(SYSTEMINFO_BigData_GetAmountParameterList);
// START BigDataTask;
//ELSE
//
//Waitms(1000);
END_IF; 
 
 
// WHILE (1)
//  SetDisplayText("ok",1,0,0);
// END_WHILE;
 
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Init()//
 SetTaskTime(TASKTIME_MAX); 
// IF (BigData_DataMode) THEN
SetDisplayText("Init BigData",5,0,0);
 StringMessageMode := SetSystemInfo(SYSTEMINFO_StringMessageMode,0);
 DataDump_len_pardef_cmn := GetSystemInfo(SYSTEMINFO_len_pardef_cmn);
 Value_SEAM_END_INPUT := GetParameter(PARA_SEAM_END_INPUT);

 BigData_Ack_Mode                      := BIGDATA_ACK_MODE_WITH_ACK;
 BigData_TxD_RepeatTime                := BIGDATA_TX_REPEATTIME;
 BigData_PowerOn_Message               := 1;
 BigData_SewInformation                := SEWINFO_STANDARD;
 BigData_MessageModeWithMessageCounter := 1;
 BigData_SendSewInformationWhenPedal0  := FALSE;
 BigData_SendSewInformationInput       := 0;
 BigData_RepeatMaxCount                := 0;
 BigData_MessageKeywords               := 0;
 BigData_UserLoginRequired             := 0;
 BigData_WatchdogTime                  := 0;
 BigData_NoACKRunBlockage              := 0;
 BigData_ExternalMachine               := FALSE;
 Disable_SectionInputOutput            := FALSE;
 Disable_PieceCounter                  := FALSE;
 Disable_ServiceTimerCounter           := FALSE;
 //SendFastSeamEnd                       := TRUE;
 DoubleSendBuffer                      := TRUE;
 Status_SendSewInformation_Trigger     := 0;
 Status_BigData_SeamManager            := 0;
 Status_ExternalMachine                := 0;
 Status_ServiceExternalMachine         := 0;
 Actual_Tx_Info                        := 0;
 BigData_TxManager_ActualFillBuffer    := 0;
 BigData_TxManager_ActualSendBuffer    := 0;
 WaitForAck                            := FALSE;
 Flag_ServiceExternalMachine           := FALSE;
 BigData_Connection_Lost               := FALSE;
 Status_Connection_Lost                := 0;
 //bDongleDetection                      := FALSE;
BigDataServiceCall_Nr                  := 0;
BigDataServiceCall_Status              := 0;
BigDataDataDump_Typ                    := 0;


 
SetDisplayText("Init Mode",5,0,0);
 SELECT (BigData_DataMode) OF
 
  CASE BIGDATA_MODE_1://Customer1-Mode
   //BigData_TxD_RepeatTime                := BIGDATA_TX_COMPILER_REPEATTIME;
   BigData_SewInformation                := SEWINFO_SPECIAL_BACKTACK;//
   //BigData_NoACKRunBlockage := 1;
   
  CASE BIGDATA_MODE_5://EFKA-Mode
   //BigData_MessageModeWithMessageCounter := 1;
   BigData_RepeatMaxCount                := BIGDATA_TX_REPEATCOUNT;
   BigData_MessageKeywords               := 1;
   BigData_UserLoginRequired             := 1;
   BigData_WatchdogTime                  := 10000;
//zu testzwecken
//   BigData_UserLoginRequired             := 0;
//   BigData_WatchdogTime                  := 0;
//   BigData_Ack_Mode                      := BIGDATA_ACK_MODE_NO_ACK;
   //BigData_SendNoBackTackInformation     := 1;
 
  CASE BIGDATA_MODE_6://Customer2-Mode
   //BigData_TxD_RepeatTime               := BIGDATA_TX_COMPILER_REPEATTIME;
   BigData_SewInformation               := SEWINFO_SPECIAL_BACKTACK;//
   BigData_NoACKRunBlockage             := 1;
//   Disable_SectionInputOutput           := TRUE;
//   Disable_PieceCounter                 := TRUE;
//   Disable_ServiceTimerCounter          := TRUE;
 
  CASE BIGDATA_MODE_8://Customer1-Mode Overlock
   //BigData_TxD_RepeatTime               := BIGDATA_TX_COMPILER_REPEATTIME;
   BigData_SewInformation               := SEWINFO_SPECIAL_BACKTACK;//
   BigData_SendSewInformationWhenPedal0 := ON;
 
  CASE BIGDATA_MODE_12://EFKA-Mode External Machine
   BigData_RepeatMaxCount                := BIGDATA_TX_REPEATCOUNT;
   BigData_MessageKeywords               := 1;
   BigData_UserLoginRequired             := 1;
   BigData_WatchdogTime                  := 10000;
   BigData_ExternalMachine               := ON;
   IF (IsDA321) THEN
    SetParameter(441,0);//IN_EXTERNAL_MACHINE_STITCHCOUNT
    SetParameter(241,0);//IN_EXTERNAL_MACHINE_START
    SetParameter(242,0);//IN_EXTERNAL_MACHINE_END
    SetParameter(442,0);//IN_EXTERNAL_MACHINE_SERVICE
   ELSE
    SetParameter(240,0);//IN_EXTERNAL_MACHINE_STITCHCOUNT
    SetParameter(241,0);//IN_EXTERNAL_MACHINE_START
    SetParameter(242,0);//IN_EXTERNAL_MACHINE_END
    SetParameter(243,0);//IN_EXTERNAL_MACHINE_SERVICE
   END_IF;

//zu testzwecken
//   BigData_PowerOn_Message               := 0;

      
  CASE BIGDATA_MODE_13://EFKA BigData Testversion no Server
   BigData_MessageKeywords               := 1;
   BigData_UserLoginRequired             := 0;
   BigData_WatchdogTime                  := 0;
   BigData_Ack_Mode                      := BIGDATA_ACK_MODE_NO_ACK;
   BigData_PowerOn_Message               := 0;
//   SendFastSeamEnd                       := TRUE;
 
  CASE BIGDATA_MODE_14://EFKA BigData Testversion no Server but with login
   BigData_MessageKeywords               := 1;
   BigData_UserLoginRequired             := 1;
   BigData_WatchdogTime                  := 10000;
   BigData_Ack_Mode                      := BIGDATA_ACK_MODE_NO_ACK;
   
  CASE BIGDATA_MODE_15://Mit wiederholung und warten auf ACK ohne Runblockage nach Einschalten //Biasys - mit Pedal 0 Lage anstatt Abschneider
   //muss noch gemacht werden
   dummy := dummy;
   
 END_SELECT;
 StringCopy(STRING_BigDataString,"");
 
 
 IF (/*(BigData_NoUserRunBlockage > 0) OR*/ (BigData_NoACKRunBlockage > 0)) THEN
  flag_BigData_SetDisablePedal  := ON;
  flag_BigData_SetRunBlockage   := ON;
  SetDisableOutM6  := ON;
  SetDisableOutM11 := ON;
  //;
 END_IF;
 
 IF (BigData_Ack_Mode = BIGDATA_ACK_MODE_WITH_ACK) THEN
 IF (BigData_PowerOn_Message > 0) THEN
  Power_On_Message_Aktiv := TRUE;
 END_IF;
 END_IF;

// SetAllDisplay_CreateDisplay();
 
// Eval_Minute_Counter := GetParameter(PARA_BIGDATA_EVALUATIONTIME);
 
// NewBigDataArray();
// 
// InitVars();//BRC disable
// WHILE (USBEnumerationIsActive)
// END_WHILE;
 
//SetDisplayText("Init Section",5,0,0);
// SECTION_DATA_Init();
 
 
SetDisplayText("Init Barcode",5,0,0);
 //Waitms(1500);
 Barcode_Init();
 //Waitms(1500);
 
 //SetDisablePedal := ON;
 //SetRunBlockage := ON;
 
// SetAllDisplayText(SADT_READY_BIGDATA,0);
 IF (BigData_PowerOn_Message) THEN   
  BigData_SendString(BIGDATA_ID_SEND_POWER_ON);
 END_IF;
 
 PieceCounter_PowerOn();
 ServiceCounter_PowerOn();
 
 
 Val_TASKTIME := GetParameter(PARA_TASKTIME);
 IF (Val_TASKTIME < TASKTIME_MIN) THEN
  Val_TASKTIME := TASKTIME_MIN;
 END_IF;
 IF (Val_TASKTIME > TASKTIME_MAX) THEN
  Val_TASKTIME := TASKTIME_MAX;
 END_IF;
 
 
 IF (BigData_UserLoginRequired) THEN
  SetAllDisplayText(SADT_INIT_LOGIN,0);
 ELSE 
  flag_BigData_SetEnableFpPedal := OFF;
  SetAllDisplay_KillDisplay();
 END_IF;

START BigDataTask;
//ELSE//IF (BigData_DataMode) THEN
// KillDisplay();
// SetEnableFpPedal := OFF;
//END_IF;//IF (BigData_DataMode) THEN
 
SetTaskTime(Val_TASKTIME*1);
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Login(BD_Log1 : VALUE, BD_Log2 : VALUE)
 BD_Log1 := VarioButtons;
 IF (BD_Log1) THEN
  SELECT (BD_Log1) OF
//---------------------------------  
//---------------------------------  
   CASE Button1: BD_Log2 := 11;
   CASE Button2: BD_Log2 := 12;
   CASE Button3: BD_Log2 := 13;
   CASE Button4: BD_Log2 := 14;
   CASE Button5: BD_Log2 := 15;
   CASE Button6: BD_Log2 := 16;
   CASE Button7: BD_Log2 := 17;
   CASE Button8: BD_Log2 := 18;
   CASE Button9: BD_Log2 := 19;
   CASE Button0: BD_Log2 := 10;

//---------------------------------  
   CASE ButtonE: //Abschicken
    IF (BigData_Ack_Mode = BIGDATA_ACK_MODE_WITH_ACK) THEN//Wenn Power on Ack noch nicht kam, muss ein Fehler angezeigt werden
    IF (BigData_PowerOn_Message > 0) THEN
    IF (Power_On_Message_Aktiv) THEN
     BigData_Connection_Lost := TRUE;
//     SetBeepShort();
//     SetAllDisplayText(SADT_ERROR_A19,BIGDATA_ERROR_TX_TIMEOUT);
    END_IF;
    END_IF;
    END_IF;
   
   
    ValueToString(STRING_BARCODE,Login_Value);
    Login_Stelle := StringLen(STRING_BARCODE);
    StringCopy(STRING_BARCODE,"");
    WHILE (Login_Stelle < 10)
     StringAppend(STRING_BARCODE,"0");
     Login_Stelle := Login_Stelle + 1;
    END_WHILE;
    ValueToString(STRING_CODE,Login_Value);
    StringAppend(STRING_BARCODE,STRING_CODE);
    IF (Login_Value) THEN
     SELECT (ActualDisplay) OF
      CASE DISPLAY_CONT_LOGIN:
       SetUserID();
      CASE DISPLAY_CONT_SERVICECALL:
       SetServiceCall();
     END_SELECT; 
     ActualDisplay := DISPLAY_WAIT_LOGIN;
    END_IF;

//---------------------------------  
   CASE ButtonP: //Aktuelle Eingabe lschen
    Login_Stelle := 0;
    Login_Value  := 0;
    SELECT (ActualDisplay) OF
     CASE DISPLAY_CONT_LOGIN:
      ShowUserValue();
     CASE DISPLAY_CONT_SERVICECALL:
      //ShowServiceCall();
     ActualDisplay := DISPLAY_WAIT_LOGIN;
     ActualDisplay := DISPLAY_INIT_SEWING;
     SetAllDisplay_KillDisplay();
    END_SELECT; 

//---------------------------------  
//---------------------------------  
  END_SELECT;

  IF (BD_Log2) THEN
   BD_Log2 := BD_Log2 - 10;
   IF (Login_Stelle >= 4) THEN
    Login_Stelle := 0;
    Login_Value := 0;
   END_IF; 

   ValueToString(STRING_CODE,Login_Value);
   ValueToString(STRING_CODE2,BD_Log2*1);
   StringAppend(STRING_CODE,STRING_CODE2);   
   Login_Value := StringToValue(STRING_CODE);
   Login_Stelle := Login_Stelle + 1;
//   IF (Login_Aktiv) THEN
//    ShowUserValue();
//   END_IF;    
//   IF (ServiceCall_Aktiv) THEN
//    ShowServiceCall();
//   END_IF;
   SELECT (ActualDisplay) OF
    CASE DISPLAY_CONT_LOGIN:
     ShowUserValue();
    CASE DISPLAY_CONT_SERVICECALL:
     ShowServiceCall();
   END_SELECT; 
   
   
  END_IF;
  WHILE (VarioButtons)
  END_WHILE;
 END_IF;
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_SewDisplay()
//SetDisplayText(STRING_OPERATOR,1,0,0);
//SELECT (Benutzer_Ebene) OF
// CASE STATUS_MECHANIC:
//  DisplayCharacterSet("mech",0,0);
// CASE STATUS_OPERATOR:
//  DisplayCharacterSet("user",0,0);
//END_SELECT;
//SetDisplayValue(Benutzer_Ebene,2,0,0);
//SetDisplayValue(OfsRdRxD*1,3,0,0);
IF (NOT MotorRun) THEN
 IF (NOT SeamFreeRun) THEN

IF (Anzeige_Naht_Text_neu <> Anzeige_Naht_Text_alt) THEN 
 IF (NOT BigData_Connection_Lost) THEN
  CreateDisplay();
  SELECT (Anzeige_Naht_Text_neu) OF
   CASE DISPLAY_INIT_CALL_SET:
    SetDisplayText("call",2,0,0);
    SetDisplayText(" set",3,0,0);
   CASE DISPLAY_INIT_CALL_OK:
    SetDisplayText("call",2,0,0);
    SetDisplayText(" ok",3,0,0);
  END_SELECT;
 END_IF; 
 Anzeige_Naht_Text_neu := Anzeige_Naht_Text_alt;
END_IF;

  Merker_VarioButtons := VarioButtons;
  IF (Merker_VarioButtons) THEN
   SELECT (Merker_VarioButtons) OF
    CASE ButtonF1:
SetBeepShort();
     BigData_SendString(BIGDATA_ID_SEND_OPERATOR_ID_LOGOUT);
     SetAllDisplayText(SADT_INIT_LOGIN,0);   
    CASE ButtonF2:
     IF (BigData_Connection_Lost) THEN
      SetBeepShort();
     ELSE 
      SetAllDisplayText(SADT_INIT_SERVICECALL,0);
      Anzeige_Naht_Text_neu := DISPLAY_INIT_CALL_SET;
     END_IF; 
   END_SELECT;
   Waitms(100);
   WHILE (VarioButtons)
   END_WHILE;
  END_IF; 
 END_IF;
END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE Barcode_Manager()
 IF (GetLine(1,STRING_BARCODE)) THEN//Sind Daten vom RFID Reader vorhanden?
  IF ( (VAL_USER_ID_1 > 0) OR (VAL_USER_ID_2 > 0) OR (VAL_USER_ID_3 > 0) ) THEN//Ist User angemeldet? 
   BigData_SendString(BIGDATA_ID_SEND_OPERATOR_ID_LOGOUT);//dann abmelden
   SetAllDisplayText(SADT_INIT_LOGIN,0);   
  ELSE//Ist kein User angemeldet?
   SELECT (ActualDisplay) OF//dann anmelden
    CASE DISPLAY_CONT_LOGIN:
     SetUserID();
     ActualDisplay := DISPLAY_WAIT_LOGIN;
   END_SELECT; 
  END_IF;
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//PROCEDURE RunBlockage_Manager()
// IF (BigData_NoUserRunBlockage > 0) THEN
//  BigData_SetRunBlockage();
// END_IF;
//END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE Display_Manager()
 SELECT (ActualDisplay) OF
  CASE DISPLAY_INIT_SEWING:
   ActualDisplay := DISPLAY_CONT_SEWING;
  CASE DISPLAY_INIT_LOGIN:
   ShowUserValue();
   ActualDisplay := DISPLAY_CONT_LOGIN;
  CASE DISPLAY_INIT_SERVICECALL:
   ShowServiceCall();
   ActualDisplay := DISPLAY_CONT_SERVICECALL;
 
  CASE DISPLAY_CONT_SEWING:
   BigData_SewDisplay();
  CASE DISPLAY_CONT_LOGIN:
   BigData_Login(0,0);
  CASE DISPLAY_CONT_SERVICECALL:
   BigData_Login(0,0);
   
  CASE DISPLAY_WAIT_LOGIN:
   dummy := dummy;
   IF (BigData_Connection_Lost) THEN
     ActualDisplay := DISPLAY_INIT_SEWING;
     SetAllDisplay_KillDisplay();
    Benutzer_Ebene := STATUS_OPERATOR;
    flag_BigData_SetEnableFpPedal := OFF;
    
   END_IF;
 END_SELECT;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE Watchdog_Manager()
 IF (BigData_WatchdogTime) THEN
  IF (NOT Power_On_Message_Aktiv) THEN
  // IF (BigData_WatchdogRun) THEN
    IF (NOT TimerIsRunning(TIMER_WATCHDOGMESSAGE)) THEN
     //SetBeepShort();
     WatchdogTimerReset();
     BigData_SendString(BIGDATA_ID_SEND_WATCHDOGMESSAGE);
    END_IF;
  // END_IF;
  END_IF;
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE ServiceTimerCounter_Manager()
IF (NOT Disable_ServiceTimerCounter) THEN
 ServiceCounter_Act_1 := ServiceCounter_Manager(1, ServiceCounter_Startwert_1*1, ServiceCounter_Mode_1*1, ServiceCounter_Act_1*1 ,0);
 ServiceCounter_Act_2 := ServiceCounter_Manager(2, ServiceCounter_Startwert_2*1, ServiceCounter_Mode_2*1, ServiceCounter_Act_2*1 ,0);
 ServiceCounter_Act_3 := ServiceCounter_Manager(3, ServiceCounter_Startwert_3*1, ServiceCounter_Mode_3*1, ServiceCounter_Act_3*1 ,0);
 ServiceCounter_Act_4 := ServiceCounter_Manager(4, ServiceCounter_Startwert_4*1, ServiceCounter_Mode_4*1, ServiceCounter_Act_4*1 ,0);
 ServiceCounter_Act_5 := ServiceCounter_Manager(5, ServiceCounter_Startwert_5*1, ServiceCounter_Mode_5*1, ServiceCounter_Act_5*1 ,0);
 //Reinit
 ServiceCounter_ExecuteCount := 0;
 ServiceCounter_ExecuteTime := 0;
END_IF; 
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Cont()


//IF (GetParameter(PARA_SHOW_CYCLE_TIME)) THEN
//// CreateDisplay();
//// SetDisplayValue(Counter_SHOW_CYCLE_TIME,1,0,0);
// IF (Counter_SHOW_CYCLE_TIME = 0) THEN
//  Counter_SHOW_CYCLE_TIME := 10;//50;
//  CreateDisplay();
//  SetDisplayValue(10000 - GetTimer(TIMER_SHOW_CYCLE_TIME),2,0,0);
//  ClearTimer(TIMER_SHOW_CYCLE_TIME);
//  SetTimer(TIMER_SHOW_CYCLE_TIME,10000);
// END_IF;
// Counter_SHOW_CYCLE_TIME := Counter_SHOW_CYCLE_TIME - 1;
//END_IF;


 IF (BigData_DataMode) THEN
 
  BigData_RxTx_Manager();
  BigData_SysIO_Manager();

//IF (Val_DEBUG_ACTIVE) THEN
// ToggleArrow();
//END_IF;

  SELECT (Ablauf_BigData_Cont) OF 
//------------------------------------------Dongle  
   CASE 1://Donle-Init
    //bDongleDetection := TRUE;
    SetDisplayText("Dong Detect",5,0,0);
    StringMessageMode := SetSystemInfo(SYSTEMINFO_StringMessageMode,1);
    BigData_Ack_Mode                      := BIGDATA_ACK_MODE_WITH_ACK;
    BigData_TxD_RepeatTime                := BIGDATA_TX_REPEATTIME;
    BigData_MessageKeywords               := 1;
    BigData_MessageModeWithMessageCounter := 0;
    BigData_SendString(DONGLE_ID_SEND_DETECT_REQUEST);
    SetTimer(TIMER_DONGLE,10000);
    Ablauf_BigData_Cont := 101;//Wait for answer
   CASE 2:// 
    SetDisplayText("Dong Enable",5,0,0);
    Dongle_Typ := SpecialFunction(SF_DONGLE_CHECK,Dongle_Val1,Dongle_Val2,Dongle_Val3,Dongle_Val4,Dongle_Val5,Dongle_Val6,Dongle_Val7,Dongle_Val8,1,0,0,0,0,0,0,0,0,0,0);
    SELECT (Dongle_Typ) OF
     CASE 1://BigData
      BigData_Ack_Mode                      := BIGDATA_ACK_MODE_NO_ACK;
      BigData_TxD_RepeatTime                := 0;
      BigData_MessageKeywords               := 1;
      BigData_MessageModeWithMessageCounter := 0;
      BigData_SendString(DONGLE_ID_SEND_DETECT_ENABLE);
      //SetTimer(TIMER_DONGLE,1000);
      Ablauf_BigData_Cont := 102;//Warten bis abgeschickt
    ELSE:
     SetAllDisplay_CreateDisplay();
     SetAllDisplayText(SADT_ERROR_DONGLE,5);
     Fkt_While();
    END_SELECT; 
    
   CASE 101:
    SetDisplayText("Dong Wait",5,0,0);
    IF (NOT TimerIsRunning(TIMER_DONGLE)) THEN
     SetAllDisplay_CreateDisplay();
     SetAllDisplayText(SADT_ERROR_DONGLE,1);
     Fkt_While();
    END_IF;
//   CASE 102:
//    IF (NOT TimerIsRunning(TIMER_DONGLE)) THEN
//     Ablauf_BigData_Cont := 500;
//    END_IF;
    
   CASE 110:
     SetAllDisplay_CreateDisplay();
     SetAllDisplayText(SADT_ERROR_DONGLE,2);
     Fkt_While();
   CASE 111:
     SetAllDisplay_CreateDisplay();
     SetAllDisplayText(SADT_ERROR_DONGLE,3);
     Fkt_While();
   CASE 112:
     SetAllDisplay_CreateDisplay();
     SetAllDisplayText(SADT_ERROR_DONGLE,4);
     Fkt_While();
     
//------------------------------------------BigData  
   CASE 500://BigData Init
    //bDongleDetection := FALSE;
    BigData_Init();
    Ablauf_BigData_Cont := 501;
   CASE 501://BigData Cont
    Barcode_Manager();
    Display_Manager(); 
    Watchdog_Manager();
//    SELECT (BigData_ExternalMachine) OF
//     CASE 1:
//      ExternalMachine_Manager(0);
//     ELSE:
//      Seam_Data_neuManager(0);
//    END_SELECT;  
    PieceCounter_Manager();
    ServiceTimerCounter_Manager();
    //RunBlockage_Manager(); 

  END_SELECT;
 END_IF;
 
// CycleCounter := CycleCounter + 1;
// SetDisplayValue(CycleCounter,1,0,0);
// SetDisplayValue(Ablauf_SendStringTest,2,0,0);
// //SetDisplayValue(BigData_TxManager_ActualFillBuffer,3,0,0);
// SetDisplayValue(Ablauf_BigData_Cont,3,0,0);
//      SetDisplayText(STRING_BigDataString,5,0,0);

 
END_PROCEDURE



//-------------------------------------------------------------------------------------------------------
END_UNIT
